		nolist

; this is an extract from the microchip application
; not and demo code for unsigned division of a 15 bit
; integer by an 8 bit integer.
; the entry point and description are at the end of the file

UDIV1507        macro
;
;       Max Timing:     3+5+14*8+2 = 122 clks
;
;       Min Timing:     3+5+14*8+2 = 122 clks
;
;       PM: 3+5+14*8+2 = 122            DM: 4
;
                variable i

                MOVFP           BARGB0,WREG
                SUBWF           REMB0, F
                RLCF            AARGB0, F

                RLCF            AARGB0,W
                RLCF            REMB0, F
                MOVFP           BARGB0,WREG
                ADDWF           REMB0, F
                RLCF            AARGB0, F

                variable i = D'2'

                while i < D'8'

                RLCF            AARGB0,W
                RLCF            REMB0, F
                MOVFP           BARGB0,WREG

                BTFSC           AARGB0,LSB
                SUBWF           REMB0, F
                BTFSS           AARGB0,LSB
                ADDWF           REMB0, F
                RLCF            AARGB0, F

                variable i=i+1

                endw

                RLCF            AARGB1,W
                RLCF            REMB0, F
                MOVFP           BARGB0,WREG

                BTFSC           AARGB0,LSB
                SUBWF           REMB0, F
                BTFSS           AARGB0,LSB
                ADDWF           REMB0, F
                RLCF            AARGB1, F

                variable i = D'9'

                while i < D'16'

                RLCF            AARGB1,W
                RLCF            REMB0, F
                MOVFP           BARGB0,WREG

                BTFSC           AARGB1,LSB
                SUBWF           REMB0, F
                BTFSS           AARGB1,LSB
                ADDWF           REMB0, F
                RLCF            AARGB1, F

                variable i=i+1

                endw

                BTFSS           AARGB1,LSB
                ADDWF           REMB0, F

                endm

 
;**********************************************************************************************
;********************************************************************************************** 
;       15/7 Bit Unsigned Fixed Point Divide 15/07 -> 15.07
;
;       Input:  15 bit unsigned fixed point dividend in AARGB0, AARGB1
;                7 bit unsigned fixed point divisor in BARGB0
;
;       Use:    CALL    FXD1507U
;
;       Output: 15 bit unsigned fixed point quotient in AARGB0, AARGB1
;               7 bit unsigned fixed point remainder in REMB0
;
;       Result: AARG, REM  <--  AARG / BARG
;
;       Max Timing:     1+122+2 = 125 clks
;
;       Min Timing:     1+122+2 = 125 clks
;
;       PM: 1+122+1 = 124               DM: 4
;
FXD1507U        CLRF            REMB0, F

                UDIV1507

                RETLW           0x00

;**********************************************************************************************
;**********************************************************************************************

		list

